s = input()
odpowiadajace_nawiasy = [0] * len(s)
stos = []
for i, znak in enumerate(s):
    if znak == '[':
        stos.append(i)
    elif znak == ']':
        ostatni = stos.pop()
        odpowiadajace_nawiasy[i] = ostatni
        odpowiadajace_nawiasy[ostatni] = i
kierunek = 1
i = 0
wynik = ""
while i < len(s):
    znak = s[i]
    if znak == '[' or znak == ']':
        i = odpowiadajace_nawiasy[i]
        kierunek = -kierunek
    else:
        wynik += znak
    i += kierunek
print(wynik)
